Attribute VB_Name = "PATorJKFaderV2"
Option Explicit
'PAT or JK Fader Bas 2.0 for a 32 bit VB

'About: This is the second version of my fader bas. What could have possibly have been
'added or done for there to be a second bas? Here's a quick run down:

' - New structure: In the first bas, every sub/function that faded colors, faded them
' within there own sub/function. In this version, only one function will fade colors and
' the other subs/function that require fading will just call that function.
' - First Letter Bold: Lets you bold and fade the first letter of every word.
' - Easier to call subs/functions: It's easier to call the subs/functions.
' - ForAol Option: This option generates html for aol things (like e-mail
' chat, ims) Yes, it is a little bit different from normal html. If you
' don't set this option then by default it's set to true.

'By PAT or JK (e-mail:patorjk@aol.com)
'Webpage: http://www.patorjk.com/
'
Dim HoldColors() As String
Dim HoldColors2() As Long
'
'NOTE: to be able to use this bas you need to know how to use the RGB function
'and how to use arrays
'Another Note: When you use html with aol, the color white (#FFFFFF) will show up as black

Public Function GetRed(ByVal Color1 As Long) As Integer
' Returns the amount of red in a color
GetRed = Color1 And 255
End Function

Public Function GetGreen(ByVal Color1 As Long) As Integer
' Returns the amount of green in a color
GetGreen = Color1 \ 256 And 255
End Function

Public Function GetBlue(ByVal Color1 As Long) As Integer
' Returns the amount of blue in a color
GetBlue = Color1 \ 65536 And 255
End Function

Public Function FadeText(Text1 As String, Colors() As Long, Optional Wave As Boolean = False, Optional ForAol As Boolean = True)
'This function generate the html text to fade text. Example on how to use:
' (put what's between the "---" in a button)
'---
'Dim Colors(1 To 3) As Long ' Here we say there are 3 colors: 1, 2, and 3
'Colors(1) = RGB(255, 0, 0) ' First Color
'Colors(2) = RGB(0, 0, 255) ' Second Color
'Colors(3) = RGB(255, 255, 0) ' Third Color
'Text1.text = FadeText(Text1, Colors(), False, False)
'---
Dim i%, i2%, DNum(1 To 3) As Double, fadedtext$, whereat%
Dim Waving(1 To 4) As String, Wn%, XMP%, numstart%, numcolor%
Dim Q$, EndFontTag$

numcolor = UBound(Colors, 1) ' Find the top of the array
numstart = LBound(Colors, 1) ' Find the bottom of the array
If numcolor < 2 Then
    ' check the number of colors in the fade
    MsgBox "You need at least 2 colors to fade.", 16, "Fade"
    FadeText = Text1
    Exit Function
End If
If numcolor > Len(Text1) Then
    ' See if you have more text or more colors
    MsgBox "Please input more text!", 16, "Fade"
    FadeText = Text1
    Exit Function
End If
If ForAol = False Then
    ' Check to see if you want the non aol html style
    Q = Chr$(34)
    EndFontTag$ = "</font>"
End If

XMP = Len(Text1)
Waving(1) = "<sub>"
Waving(2) = "</sub>"
Waving(3) = "<sup>"
Waving(4) = "</sup>"
Wn% = 1

' Call the sub fade the colors
Call FadeColors(Colors(), Len(Text1), ForAol)

whereat% = 1
For i = 1 To Len(Text1)
    If Asc(Mid(Text1, whereat%, 1)) = 13 Then
      ' See if you want to go to the next line
      fadedtext$ = fadedtext$ + "<br>"
    ElseIf Asc(Mid(Text1, whereat%, 1)) = 10 Then
    Else
      If Wave = True Then
       fadedtext$ = fadedtext$ + HoldColors(i) + Waving(Wn%) + Mid$(Text1, whereat%, 1) + EndFontTag$
      Else
       fadedtext$ = fadedtext$ + HoldColors(i) + Mid$(Text1, whereat%, 1) + EndFontTag$
      End If
      Wn% = Wn% + 1
      If Wn% > 4 Then Wn% = 1
    End If
      whereat% = whereat% + 1
Next i
FadeText = fadedtext$
End Function

Function Cov(S As String) As String
' This functions pads/covers hex numbers
Do While Len(S) < 2
    S = "0" + S
Loop
Cov = S
End Function

Public Function FirstLetterBold(text As String, Colors() As Long, Optional ForAol As Boolean = True) As String
'This function returns a string that has the first letter of every word
'bolded (with html tags). It also fades the color of the first bolded
'letter, with the last bolded letter. Example on how to use: (put the
'following text the is between the "---" in a button.)

'---
'Dim Colors(1 To 2) As Long 'Here we say there are 3 colors: 1, 2, and 3
'Colors(1) = RGB(255, 0, 0) ' First Color
'Colors(2) = RGB(0, 0, 255) ' Second Color
'Text1.text = FirstLetterBold(Text1, Colors(), True)
'---
Dim i As Integer, X As Integer, c As Integer, Q As String
Dim EndFontTag$, TakeOff As Integer, BColor As String, TheEnd$, NumFL As Integer

ReDim FLetter(1 To 3) As String
FLetter(1) = Chr$(32) ' You bold the letter that comes
FLetter(2) = Chr$(34) ' after each one of these
FLetter(3) = Chr$(10) ' characters

If ForAol = False Then
    ' Check if you want the non aol html style
    Q = Chr$(34)
    EndFontTag$ = "</font>"
    TakeOff = 13
    TheEnd$ = "<font color=" & Q & "#000000" & Q & ">"
Else
    BColor = "<font color=#000000>"
End If

text = Trim(text)
NumFL = CountFirstLetters(text)

If NumFL + 1 < UBound(Colors, 1) Then
    ' check the number of first letters to the number of colors
    MsgBox "Error", 16, "Fade"
    FirstLetterBold = text
    Exit Function
End If

' fade the colors
Call FadeColors(Colors(), NumFL, ForAol)
c = 1
If InStr("abcdefghijklmnopqrstuvwxyz1234567890", LCase$(Mid$(text, i + 1, 1))) <> 0 Then
    text = HoldColors(c) & "<b>" & Mid$(text, 1, 1) + "</b>" + EndFontTag$ + BColor + Mid$(text, 2)
End If
i = InStr(i + 1, text, "</b>") + 23 - TakeOff

For X = LBound(FLetter, 1) To UBound(FLetter, 1)
    Do While InStr(i + 1, text, FLetter(X)) <> 0
        i = InStr(i + 1, text, FLetter(X))
        If InStr("abcdefghijklmnopqrstuvwxyz1234567890", LCase$(Mid$(text, i + 1, 1))) <> 0 And i <> Len(text) Then
            c = c + 1
            text = Mid$(text, 1, i) & HoldColors(c) & "<b>" & Mid$(text, i + 1, 1) & "</b>" & EndFontTag$ & BColor & Mid$(text, i + 2)
            i = InStr(i + 1, text, "</b>") + 22 - TakeOff
        End If
    Loop
    i = 0
Next
FirstLetterBold = TheEnd$ + text + EndFontTag$
End Function

Public Sub FadeColors(Colors() As Long, NumColors As Integer, Optional ForAol As Boolean = True)
' This is the sub we use to fade colors
Dim i%, i2%, DNum(1 To 3) As Double, numstart%, numcolor%, Q$
Dim HoldOld%
numcolor = UBound(Colors, 1)
numstart = LBound(Colors, 1)
ReDim TheColors(numstart To numcolor, 1 To 3) As Double

If ForAol = False Then Q = Chr$(34)
For i = numstart To numcolor
  TheColors(i, 1) = GetRed(Colors(i))
  TheColors(i, 2) = GetGreen(Colors(i))
  TheColors(i, 3) = GetBlue(Colors(i))
Next

' Set the arrays back at zero
ReDim HoldColors(0) As String
ReDim HoldColors2(0) As Long

For i = 1 To (numcolor - 1)
  DNum(1) = (TheColors(i + 1, 1) - TheColors(i, 1)) / (NumColors / (numcolor - 1))
  DNum(2) = (TheColors(i + 1, 2) - TheColors(i, 2)) / (NumColors / (numcolor - 1))
  DNum(3) = (TheColors(i + 1, 3) - TheColors(i, 3)) / (NumColors / (numcolor - 1))

  For i2 = numstart To (NumColors \ (numcolor - 1))
    HoldOld = HoldOld + 1
    ReDim Preserve HoldColors(HoldOld) As String ' make the array a little bigger
    ReDim Preserve HoldColors2(HoldOld) As Long  ' make the array a little bigger
    HoldColors(HoldOld) = "<font color=" & Q & "#" + Cov(Hex(TheColors(i, 1))) + Cov(Hex(TheColors(i, 2))) + Cov(Hex(TheColors(i, 3))) + Q + ">"
    HoldColors2(HoldOld) = RGB(TheColors(i, 1), TheColors(i, 2), TheColors(i, 3))
    TheColors(i, 1) = TheColors(i, 1) + DNum(1) ' Move red/green/blue in
    TheColors(i, 2) = TheColors(i, 2) + DNum(2) ' the color up/down a
    TheColors(i, 3) = TheColors(i, 3) + DNum(3) ' step
  Next i2
Next i

For i = HoldOld To NumColors - 1
  ' for any stuff that might be left over, eh, just set it to the last color
  HoldOld = HoldOld + 1
  ReDim Preserve HoldColors(HoldOld) As String
  ReDim Preserve HoldColors2(HoldOld) As Long
  HoldColors(HoldOld) = "<font color=" & Q & "#" + Cov(Hex(TheColors(numcolor, 1))) + Cov(Hex(TheColors(numcolor, 2))) + Cov(Hex(TheColors(numcolor, 3))) + Q + ">"
  HoldColors2(HoldOld) = RGB(TheColors(numcolor, 1), TheColors(numcolor, 2), TheColors(numcolor, 3))
Next
End Sub

Public Function CountFirstLetters(text As String) As Integer
'This sub returns the number of first letters that are in a string.
Dim i As Integer, X As Integer, fcount As Integer
ReDim FLetter(1 To 3) As String
FLetter(1) = Chr$(32)
FLetter(2) = Chr$(34)
FLetter(3) = Chr$(10)
fcount = 1
For X = LBound(FLetter, 1) To UBound(FLetter, 1)
    Do While InStr(i + 1, text, FLetter(X)) <> 0
        i = InStr(i + 1, text, FLetter(X))
        If InStr("abcdefghijklmnopqrstuvwxyz", LCase$(Mid$(text, i + 1, 1))) <> 0 And i <> Len(text) Then
        fcount = fcount + 1
        End If
    Loop
    i = 0
Next
CountFirstLetters = fcount
End Function

Sub FadeBackground(What As Object, Colors() As Long, Optional Top2Bottom_not_Side2Side As Boolean = True)
'This sub will fade the background an object (like a picture or a form)
'Example on how to use: (put the code between the "---" in the load event of the form)
'(NOTE: make sure the object's autoredraw property is set to true or if you're
' using a form you can put that code in the Paint event of it)
'---
'Dim Colors(1 To 2) As Long
'Colors(1) = RGB(0, 158, 158)
'Colors(2) = RGB(0, 0, 0)
'Call FadeBackground(Me, Colors(), True)
'---
On Error Resume Next
Dim i%, i2%, DNum(1 To 3) As Single, TheA As Integer
Dim X As Single, x2 As Double, Y%

If Top2Bottom_not_Side2Side = True Then
    x2 = What.ScaleHeight / 100
    Y% = What.ScaleWidth
Else
    x2 = What.ScaleWidth / 100
    Y% = What.ScaleHeight
End If

Call FadeColors(Colors(), 100, False)

What.Cls
What.BackColor = HoldColors2(UBound(HoldColors2, 1))

For i = 1 To 100
    If Top2Bottom_not_Side2Side = True Then
        What.Line (0, X)-(Y%, X + x2), HoldColors2(i), BF
    Else
        What.Line (X, 0)-(X + x2, Y%), HoldColors2(i), BF
    End If
    X = X + x2
Next i
End Sub
